#include <SenderThread.h>
#include <AMI_DBEngineHome_findI.h>
#include <iostream>
#include <time.h>

using namespace std;
using namespace pnote;

extern vector<unsigned long> vect_lInCount;
extern vector<unsigned long> vect_lOutCount;

/*
SenderThread::SenderThread()
{
	//lInCount = 0;
	//lOutCount = 0;
	_iThreadIndex = 0;
}
*/

SenderThread::SenderThread(bool isSyncIn,unsigned long iMaxSendNumIn,const Ice::PropertiesPtr & props,short iThreadIndex)
{
	isSync = isSyncIn;
	iMaxSendNum = iMaxSendNumIn;

	int iCount = 0;
	//lOutCount = 0;
	_iThreadIndex = iThreadIndex;

	//_communicator = Ice::initialize(argc,argv);
	_communicator = Ice::initializeWithProperties(iCount,NULL,props);

	//_properties = _communicator->getProperties();
	_properties = props;

	//cout << "iMaxSendNum: " << iMaxSendNum << endl;
	isRunningLongTime = false;
	if (iMaxSendNum == 0)
	{	
		iMaxSendNum = 1;
		isRunningLongTime = true;
	}
}

void SenderThread::run()
{
	time_t tmStart;
	time_t tmEnd;

	memset(&tmStart,0,sizeof(tmStart));
	memset(&tmEnd,0,sizeof(tmEnd));
	
	try
	{
		const char* proxyProperty = "DBEngineHome.Proxy";
        std::string strProxyName = _properties->getProperty(proxyProperty);
        if(strProxyName.empty())
        {
            cerr <<" property `" << proxyProperty << "' not set" << endl;
            return;
        }

        Ice::ObjectPrx obj = _communicator->stringToProxy(strProxyName);
        //Ice::ObjectPrx obj = communicator->stringToProxy("phonelist:default -p 10000");


        DBEngineHomePrx homePrx = DBEngineHomePrx::checkedCast(obj);
		if (!homePrx)
		{
			cerr << "Proxy error, Can't create DBEngineHomePrx" << endl;
		}

		time(&tmStart);
			
		if (isSync)
		{
			cout << "SenderThread id->" << _iThreadIndex << " is running in Sync mode ..." << endl;
			while (!isInterrupted && (iMaxSendNum >0 ))
			{
				getPhoneNo();

				try
                {
					data = homePrx->find(_id,_phoneno);
					vect_lInCount[_iThreadIndex]++ ;
					vect_lOutCount[_iThreadIndex]++ ;
				}catch (const ShutDownError & ex)
                {
       				isInterrupted = true;
					cerr << "catch ShutDownError: " << ex.reason << endl;
                } catch (const Ice::Exception & ex)
                {
                    cerr << "send async data error:" << ex << endl;
       				isInterrupted = true;
		            //break;

                }

				
				if (!isRunningLongTime)
				{
					--iMaxSendNum;
				}
			}
		
		} else //Async
		{
			AMI_DBEngineHome_findPtr cbPtr = new AMI_DBEngineHome_findI(_iThreadIndex);
			cout << "SenderThread id->" << _iThreadIndex << " is running in Async mode ..." << endl;
			while (!isInterrupted && (iMaxSendNum >0 ))
			{
				getPhoneNo();
				try
				{
					homePrx->find_async(cbPtr,_id,_phoneno);
					vect_lInCount[_iThreadIndex]++ ;
				}catch (const ShutDownError & ex)
                {
       				isInterrupted = true;
					cerr << "catch ShutDownError: " << ex.reason << endl;
				} catch (const Ice::Exception & ex)
				{
					cerr << "send async data error:" << ex << endl;
       				isInterrupted = true;
					//break;

				}
				//++lInCount;
			
				if (!isRunningLongTime)
				{
					--iMaxSendNum;
				}
				
			}
		
			//cout << "isRunningLongTime:" <<isRunningLongTime << endl;
			//cout << "iMaxSendNum: " << iMaxSendNum << endl;
			
		} /* if (isSync) */

		time(&tmEnd);

	} catch (const Ice::Exception & e)
    {
        cerr << "send data error:" << e << endl;
    } catch (const char * msg) {
        cerr << "send data error:" << msg << endl;
    }
	
	if (_communicator)
	{
		_communicator->destroy();
	}

	long interval = (tmEnd-tmStart);
	if (interval == 0)
	{
		interval = 1;
	}
	//cout << "   Total Time:" << interval << endl;
	
	long in_s = (long)(vect_lInCount[_iThreadIndex]/interval);
	long out_s = (long)(vect_lOutCount[_iThreadIndex]/interval);

	cout << "SenderThread id->" << _iThreadIndex << " Total:" << endl;

	cout << "----------------------------------------- " << endl;
	cout << "   start time:    " << ctime(&tmStart) ;
	cout << "   End time:      " << ctime(&tmEnd);
	cout << "   Total Time:    " << interval << "s" << endl;
	cout << "   Sent data:     " << vect_lInCount[_iThreadIndex] << endl;
	cout << "   Received data: " << vect_lOutCount[_iThreadIndex] << endl;
	cout << "   In/s:  " << in_s << " ,  In/h:  " << in_s * 60 * 60 << endl;
	cout << "   Out/s: " << out_s <<" ,  Out/h: " << out_s * 60 * 60 << endl;
	cout << "----------------------------------------- " << endl;

}

void SenderThread::getPhoneNo()
{
	_id++;

	_phoneno = "1382343433444";
}



