// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.1
// Generated from file `dbengine.ice'

#include <dbengine.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10501
#       error Ice version mismatch!
#   endif
#endif

void
IceInternal::incRef(::pnote::DBEngineHome* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::pnote::DBEngineHome* p)
{
    p->__decRef();
}

void
IceInternal::incRef(::IceProxy::pnote::DBEngineHome* p)
{
    p->__incRef();
}

void
IceInternal::decRef(::IceProxy::pnote::DBEngineHome* p)
{
    p->__decRef();
}

void
pnote::__write(::IceInternal::BasicStream* __os, const ::pnote::DBEngineHomePrx& v)
{
    __os->write(::Ice::ObjectPrx(v));
}

void
pnote::__read(::IceInternal::BasicStream* __is, ::pnote::DBEngineHomePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
	v = 0;
    }
    else
    {
	v = new ::IceProxy::pnote::DBEngineHome;
	v->__copyFrom(proxy);
    }
}

void
pnote::__write(::IceInternal::BasicStream* __os, const ::pnote::DBEngineHomePtr& v)
{
    __os->write(::Ice::ObjectPtr(v));
}

const ::std::string pnote::ShutDownError::_name = "pnote::ShutDownError";

const ::std::string&
pnote::ShutDownError::ice_name() const
{
    return pnote::ShutDownError::_name;
}

::Ice::Exception*
pnote::ShutDownError::ice_clone() const
{
    return new ShutDownError(*this);
}

void
pnote::ShutDownError::ice_throw() const
{
    throw *this;
}

const ::IceInternal::UserExceptionFactoryPtr&
pnote::ShutDownError::ice_factory()
{
    return _factory;
}

void
pnote::ShutDownError::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(::std::string("::pnote::ShutDownError"));
    __os->startWriteSlice();
    __os->write(reason);
    __os->endWriteSlice();
}

void
pnote::ShutDownError::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->read(myId);
    }
    __is->startReadSlice();
    __is->read(reason);
    __is->endReadSlice();
}

class __F__pnote__ShutDownError : public ::IceInternal::UserExceptionFactory
{
public:

    virtual void
    createAndThrow()
    {
	throw ::pnote::ShutDownError();
    }
};

::IceInternal::UserExceptionFactoryPtr pnote::ShutDownError::_factory = new __F__pnote__ShutDownError;

class __F__pnote__ShutDownError__Init
{
public:

    __F__pnote__ShutDownError__Init()
    {
	::Ice::factoryTable->addExceptionFactory("::pnote::ShutDownError", ::pnote::ShutDownError::ice_factory());
    }

    ~__F__pnote__ShutDownError__Init()
    {
	::Ice::factoryTable->removeExceptionFactory("::pnote::ShutDownError");
    }
};

static __F__pnote__ShutDownError__Init __F__pnote__ShutDownError__i;

#ifdef __APPLE__
extern "C" { void __F__pnote__ShutDownError__initializer() {} }
#endif

bool
pnote::DBEngineData::operator==(const DBEngineData& __rhs) const
{
    return !operator!=(__rhs);
}

bool
pnote::DBEngineData::operator!=(const DBEngineData& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(ID != __rhs.ID)
    {
	return true;
    }
    if(GroupID != __rhs.GroupID)
    {
	return true;
    }
    if(RuleID != __rhs.RuleID)
    {
	return true;
    }
    if(ContentFlag != __rhs.ContentFlag)
    {
	return true;
    }
    if(ContentID != __rhs.ContentID)
    {
	return true;
    }
    if(DCS != __rhs.DCS)
    {
	return true;
    }
    if(content != __rhs.content)
    {
	return true;
    }
    return false;
}

bool
pnote::DBEngineData::operator<(const DBEngineData& __rhs) const
{
    if(this == &__rhs)
    {
	return false;
    }
    if(ID < __rhs.ID)
    {
	return true;
    }
    else if(__rhs.ID < ID)
    {
	return false;
    }
    if(GroupID < __rhs.GroupID)
    {
	return true;
    }
    else if(__rhs.GroupID < GroupID)
    {
	return false;
    }
    if(RuleID < __rhs.RuleID)
    {
	return true;
    }
    else if(__rhs.RuleID < RuleID)
    {
	return false;
    }
    if(ContentFlag < __rhs.ContentFlag)
    {
	return true;
    }
    else if(__rhs.ContentFlag < ContentFlag)
    {
	return false;
    }
    if(ContentID < __rhs.ContentID)
    {
	return true;
    }
    else if(__rhs.ContentID < ContentID)
    {
	return false;
    }
    if(DCS < __rhs.DCS)
    {
	return true;
    }
    else if(__rhs.DCS < DCS)
    {
	return false;
    }
    if(content < __rhs.content)
    {
	return true;
    }
    else if(__rhs.content < content)
    {
	return false;
    }
    return false;
}

void
pnote::DBEngineData::__write(::IceInternal::BasicStream* __os) const
{
    __os->write(ID);
    __os->write(GroupID);
    __os->write(RuleID);
    __os->write(ContentFlag);
    __os->write(ContentID);
    __os->write(DCS);
    __os->write(content);
}

void
pnote::DBEngineData::__read(::IceInternal::BasicStream* __is)
{
    __is->read(ID);
    __is->read(GroupID);
    __is->read(RuleID);
    __is->read(ContentFlag);
    __is->read(ContentID);
    __is->read(DCS);
    __is->read(content);
}

void
pnote::AMI_DBEngineHome_find::__invoke(const ::pnote::DBEngineHomePrx& __prx, ::Ice::Long ID, const ::std::string& strPhoneNo, const ::Ice::Context& __ctx)
{
    try
    {
	static const ::std::string __operation("find");
	__prepare(__prx, __operation, static_cast< ::Ice::OperationMode>(1), __ctx);
	__os->write(ID);
	__os->write(strPhoneNo);
	__os->endWriteEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
	__finished(__ex);
	return;
    }
    __send();
}

void
pnote::AMI_DBEngineHome_find::__response(bool __ok)
{
    ::pnote::DBEngineData __ret;
    try
    {
	if(!__ok)
	{
	    __is->throwException();
	}
	__ret.__read(__is);
    }
    catch(const ::Ice::LocalException& __ex)
    {
	__finished(__ex);
	return;
    }
    catch(const ::Ice::UserException& __ex)
    {
	ice_exception(__ex);
	return;
    }
    ice_response(__ret);
}

IceAsync::pnote::AMD_DBEngineHome_find::AMD_DBEngineHome_find(::IceInternal::Incoming& in) :
    IncomingAsync(in)
{
}

void
IceAsync::pnote::AMD_DBEngineHome_find::ice_response(const ::pnote::DBEngineData& __ret)
{
    if(!_finished)
    {
	try
	{
	    ::IceInternal::BasicStream* __os = this->__os();
	    __ret.__write(__os);
	}
	catch(const ::Ice::Exception& __ex)
	{
	    __exception(__ex);
	    return;
	}
	__response(true);
    }
}

void
IceAsync::pnote::AMD_DBEngineHome_find::ice_exception(const ::Ice::Exception& ex)
{
    if(!_finished)
    {
	try
	{
	    ex.ice_throw();
	}
	catch(const ::pnote::ShutDownError& __ex)
	{
	    __os()->write(__ex);
	    __response(false);
	}
	catch(const ::Ice::Exception& __ex)
	{
	    __exception(__ex);
	}
    }
}

void
IceAsync::pnote::AMD_DBEngineHome_find::ice_exception(const ::std::exception& ex)
{
    if(!_finished)
    {
	__exception(ex);
    }
}

void
IceAsync::pnote::AMD_DBEngineHome_find::ice_exception()
{
    if(!_finished)
    {
	__exception();
    }
}

::pnote::DBEngineData
IceProxy::pnote::DBEngineHome::find(::Ice::Long ID, const ::std::string& strPhoneNo)
{
    return find(ID, strPhoneNo, __defaultContext());
}

::pnote::DBEngineData
IceProxy::pnote::DBEngineHome::find(::Ice::Long ID, const ::std::string& strPhoneNo, const ::Ice::Context& __ctx)
{
    int __cnt = 0;
    while(true)
    {
	try
	{
	    __checkTwowayOnly("find");
	    ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase = __getDelegate();
	    ::IceDelegate::pnote::DBEngineHome* __del = dynamic_cast< ::IceDelegate::pnote::DBEngineHome*>(__delBase.get());
	    return __del->find(ID, strPhoneNo, __ctx);
	}
	catch(const ::IceInternal::NonRepeatable& __ex)
	{
	    __handleException(*__ex.get(), __cnt);
	}
	catch(const ::Ice::LocalException& __ex)
	{
	    __handleException(__ex, __cnt);
	}
    }
}

void
IceProxy::pnote::DBEngineHome::find_async(const ::pnote::AMI_DBEngineHome_findPtr& __cb, ::Ice::Long ID, const ::std::string& strPhoneNo)
{
    find_async(__cb, ID, strPhoneNo, __defaultContext());
}

void
IceProxy::pnote::DBEngineHome::find_async(const ::pnote::AMI_DBEngineHome_findPtr& __cb, ::Ice::Long ID, const ::std::string& strPhoneNo, const ::Ice::Context& __ctx)
{
    __checkTwowayOnly("find");
    __cb->__invoke(this, ID, strPhoneNo, __ctx);
}

const ::std::string&
IceProxy::pnote::DBEngineHome::ice_staticId()
{
    return ::pnote::DBEngineHome::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::pnote::DBEngineHome::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::pnote::DBEngineHome);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::pnote::DBEngineHome::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::pnote::DBEngineHome);
}

bool
IceProxy::pnote::operator==(const ::IceProxy::pnote::DBEngineHome& l, const ::IceProxy::pnote::DBEngineHome& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) == static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::pnote::operator!=(const ::IceProxy::pnote::DBEngineHome& l, const ::IceProxy::pnote::DBEngineHome& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) != static_cast<const ::IceProxy::Ice::Object&>(r);
}

bool
IceProxy::pnote::operator<(const ::IceProxy::pnote::DBEngineHome& l, const ::IceProxy::pnote::DBEngineHome& r)
{
    return static_cast<const ::IceProxy::Ice::Object&>(l) < static_cast<const ::IceProxy::Ice::Object&>(r);
}

::pnote::DBEngineData
IceDelegateM::pnote::DBEngineHome::find(::Ice::Long ID, const ::std::string& strPhoneNo, const ::Ice::Context& __context)
{
    static const ::std::string __operation("find");
    ::IceInternal::Outgoing __out(__connection.get(), __reference.get(), __operation, static_cast< ::Ice::OperationMode>(1), __context, __compress);
    ::IceInternal::BasicStream* __os = __out.os();
    __os->write(ID);
    __os->write(strPhoneNo);
    bool __ok = __out.invoke();
    try
    {
	::IceInternal::BasicStream* __is = __out.is();
	if(!__ok)
	{
	    __is->throwException();
	}
	::pnote::DBEngineData __ret;
	__ret.__read(__is);
	return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
	throw ::IceInternal::NonRepeatable(__ex);
    }
}

::pnote::DBEngineData
IceDelegateD::pnote::DBEngineHome::find(::Ice::Long, const ::std::string&, const ::Ice::Context&)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

const ::std::string pnote::DBEngineHome::__ids[2] =
{
    "::Ice::Object",
    "::pnote::DBEngineHome"
};

bool
pnote::DBEngineHome::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__ids, __ids + 2, _s);
}

::std::vector< ::std::string>
pnote::DBEngineHome::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__ids[0], &__ids[2]);
}

const ::std::string&
pnote::DBEngineHome::ice_id(const ::Ice::Current&) const
{
    return __ids[1];
}

const ::std::string&
pnote::DBEngineHome::ice_staticId()
{
    return __ids[1];
}

::IceInternal::DispatchStatus
pnote::DBEngineHome::___find(::IceInternal::Incoming& __in, const ::Ice::Current& __current) const
{
    ::IceInternal::BasicStream* __is = __in.is();
    ::Ice::Long ID;
    ::std::string strPhoneNo;
    __is->read(ID);
    __is->read(strPhoneNo);
    ::pnote::AMD_DBEngineHome_findPtr __cb = new IceAsync::pnote::AMD_DBEngineHome_find(__in);
    try
    {
	find_async(__cb, ID, strPhoneNo, __current);
    }
    catch(const ::Ice::Exception& __ex)
    {
	__cb->ice_exception(__ex);
    }
    catch(const ::std::exception& __ex)
    {
	__cb->ice_exception(__ex);
    }
    catch(...)
    {
	__cb->ice_exception();
    }
    return ::IceInternal::DispatchAsync;
}

::std::string pnote::DBEngineHome::__all[] =
{
    "find",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping"
};

::IceInternal::DispatchStatus
pnote::DBEngineHome::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__all, __all + 5, current.operation);
    if(r.first == r.second)
    {
	return ::IceInternal::DispatchOperationNotExist;
    }

    switch(r.first - __all)
    {
	case 0:
	{
	    return ___find(in, current);
	}
	case 1:
	{
	    return ___ice_id(in, current);
	}
	case 2:
	{
	    return ___ice_ids(in, current);
	}
	case 3:
	{
	    return ___ice_isA(in, current);
	}
	case 4:
	{
	    return ___ice_ping(in, current);
	}
    }

    assert(false);
    return ::IceInternal::DispatchOperationNotExist;
}

void
pnote::DBEngineHome::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
pnote::DBEngineHome::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
	::std::string myId;
	__is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void 
pnote::__patch__DBEngineHomePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::pnote::DBEngineHomePtr* p = static_cast< ::pnote::DBEngineHomePtr*>(__addr);
    assert(p);
    *p = ::pnote::DBEngineHomePtr::dynamicCast(v);
    if(v && !*p)
    {
	::Ice::NoObjectFactoryException e(__FILE__, __LINE__);
	e.type = ::pnote::DBEngineHome::ice_staticId();
	throw e;
    }
}

bool
pnote::operator==(const ::pnote::DBEngineHome& l, const ::pnote::DBEngineHome& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
pnote::operator!=(const ::pnote::DBEngineHome& l, const ::pnote::DBEngineHome& r)
{
    return static_cast<const ::Ice::Object&>(l) != static_cast<const ::Ice::Object&>(r);
}

bool
pnote::operator<(const ::pnote::DBEngineHome& l, const ::pnote::DBEngineHome& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
