//#include <loadapplication.h>
#include <Ice/Ice.h>
#include <IceUtil/CtrlCHandler.h>
//#include <signal.h>
#include <SenderThread.h>
#include <iostream>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>
#include <time.h>

#include <errno.h>

using namespace std;


extern int errno;

/* Flag set by '--verbose' */
static  int verbose_flag;

static void parseArg(int argc,char* argv[]);
static void usage(int argc,char* argv[]);
static void printVersion();

vector<unsigned long> vect_lInCount;
vector<unsigned long> vect_lOutCount;

bool SenderThread::isInterrupted = false;
int iThreadCount = 1;
bool isSync = false;
unsigned long iMaxSendNum = 0;

void handleSignal(int Signal)
{
	SenderThread::isInterrupted = true;
	cerr <<"shutdown on interrupt." << endl;

}

int
main(int argc, char * argv[])
{
	time_t tmStart;
    time_t tmEnd;

	memset(&tmStart,0,sizeof(tmStart));
    memset(&tmEnd,0,sizeof(tmEnd));


	IceUtil::CtrlCHandler handler(handleSignal);

	Ice::PropertiesPtr properties = Ice::getDefaultProperties(argc,argv);

	parseArg(argc, argv);
	//int iThreadCount = properties->getPropertyAsIntWithDefault("thread",1);

	vector<IceUtil::ThreadControl> threadPool;

	for (int i = 0;i<iThreadCount;i++)
	{
		vect_lInCount.push_back(0);
		vect_lOutCount.push_back(0);
		
		IceUtil::ThreadPtr t = new SenderThread(isSync,iMaxSendNum,properties,i);
		threadPool.push_back(t->start());

	}

	time(&tmStart);	
	for (vector<IceUtil::ThreadControl>::iterator i = threadPool.begin(); i != threadPool.end(); ++i) 
	{ 
		i->join();
	}
	time(&tmEnd);

	//sleep(1);

	long interval = (tmEnd-tmStart);
    if (interval == 0)
    {
        interval = 1;
    }
    //cout << "   Total Time:" << interval << endl;

	unsigned long lTotal_In = 0;
	unsigned long lTotal_Out = 0;
	
	for (unsigned int i = 0;i<vect_lInCount.size();i++)
	{
		lTotal_In += vect_lInCount[i];
		lTotal_Out += vect_lOutCount[i];
	}

    long in_s = (long)(lTotal_In/interval);
    long out_s = (long)(lTotal_Out/interval);

    cout << "All SenderThreads (" << threadPool.size() << " threads) Total:" << endl;

    cout << "----------------------------------------- " << endl;
    cout << "   start time:    " << ctime(&tmStart) ;
    cout << "   End time:      " << ctime(&tmEnd);
    cout << "   Total Time:    " << interval << "s" << endl;
    cout << "   Sent data:     " << lTotal_In << endl;
    cout << "   Received data: " << lTotal_Out << endl;
    cout << "   In/s:  " << in_s << " ,  In/h:  " << in_s * 60 * 60 << endl;
    cout << "   Out/s: " << out_s <<" ,  Out/h: " << out_s * 60 * 60 << endl;
    cout << "----------------------------------------- " << endl;


	return 0;
}

static void 
parseArg(int argc,char* argv[])
{
	//printf("check point 10\n");
	/*
	if (1 == argc)
	{
		cout <<"No argument. Please see usage." << endl;
		usage(argc,argv);
	}
	*/	
	
	int c;
	while (1)
	{
		static struct option long_options[] =
		{
			/* These options set a flag */
			{"help",0,0,'H'},
			{"version",0,0,'V'},
			{"sync",0,0,'s'},
			{"num",1,0,'n'},
			{"thread",1,0,'t'}
		};

		/* getopt_long stores the option index here */

		int option_index = 0;
		c = getopt_long(argc,argv,"HVsn:t:",long_options,&option_index);

		if (c == -1)
			break;

		switch(c)
		{
			case 0:
				/* If this option set a flag,do nothing else now */
				if (long_options[option_index].flag != 0)
					break;
				printf("option %s",long_options[option_index].name);
				  
				if (optarg)
					printf(" with arg %s\n",optarg);
				break;

			case 'H':
				usage(argc,argv);
				break;
			case 'V':
				printVersion();
				break;

			case 's':
				isSync = true;
				break;

			case 't':
				iThreadCount = atoi(optarg);
				break;

			case 'n':
				iMaxSendNum = atol(optarg);
				break;
				  
			case '?':
				/* getopt_long already printed an error message. */
				usage(argc,argv);
				break;
				  
			default:
				usage(argc,argv);
				break;

		} //end switch(c)

	} /* The end of while (1) */

	//printf("check point 10");
	if (verbose_flag)
		printf("verbose flag is set");

	if (optind < argc)
	{
		printf("Unknow ARGV-elements:");
		while (optind < argc)
			printf(" %s ",argv[optind++]);

		printf("\n");
		usage(argc,argv);

	}
}


static void 
usage(int argc,char* argv[])
{
		cout<< "Usage:" << endl;
		cout << "\t" << argv[0]<< " [OPTION]" <<endl;
		cout << "[OPTION]" << endl;
		cout << "\t-H --help\t display this help and exit" << endl;
		cout << "\t-V --version\t display this program version and exit" << endl;
		cout << "\t-t=nnn --thread=nnn\t set Thread NUmber to run" << endl;
		cout << "\t-n=nnn --num=nnn\t set Max Send times." << endl;
		cout << "\t-s --sync\t use sync method,default system use async method" << endl;


		exit(0);

}



static void 
printVersion()
{
	char* pAppName = "loadTest";
	char* pAppVersion = "1.0";
	
	cout << pAppName << "-" << pAppVersion << endl;

	exit(0);

}
