// **********************************************************************
//
// Copyright (c) 2003-2004 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 1.5.1
// Generated from file `dbengine.ice'

#ifndef ________pnote_db_test_dbengine_h__
#define ________pnote_db_test_dbengine_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION != 10501
#       error Ice version mismatch!
#   endif
#endif

namespace IceProxy
{

namespace pnote
{

class DBEngineHome;
bool operator==(const DBEngineHome&, const DBEngineHome&);
bool operator!=(const DBEngineHome&, const DBEngineHome&);
bool operator<(const DBEngineHome&, const DBEngineHome&);

}

}

namespace pnote
{

class DBEngineHome;
bool operator==(const DBEngineHome&, const DBEngineHome&);
bool operator!=(const DBEngineHome&, const DBEngineHome&);
bool operator<(const DBEngineHome&, const DBEngineHome&);

}

namespace IceInternal
{

void incRef(::pnote::DBEngineHome*);
void decRef(::pnote::DBEngineHome*);

void incRef(::IceProxy::pnote::DBEngineHome*);
void decRef(::IceProxy::pnote::DBEngineHome*);

}

namespace pnote
{

typedef ::IceInternal::Handle< ::pnote::DBEngineHome> DBEngineHomePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::pnote::DBEngineHome> DBEngineHomePrx;

void __write(::IceInternal::BasicStream*, const DBEngineHomePrx&);
void __read(::IceInternal::BasicStream*, DBEngineHomePrx&);
void __write(::IceInternal::BasicStream*, const DBEngineHomePtr&);
void __read(::IceInternal::BasicStream*, DBEngineHomePtr&);
void __patch__DBEngineHomePtr(void*, ::Ice::ObjectPtr&);

}

namespace pnote
{

typedef ::std::vector< ::Ice::Byte> ContentList;

class ShutDownError : public ::Ice::UserException
{
public:

    virtual const ::std::string& ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string reason;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);

private:

    static ::IceInternal::UserExceptionFactoryPtr _factory;

    static const ::std::string _name;
};

struct DBEngineData
{
    ::Ice::Long ID;

    ::Ice::Short GroupID;

    ::Ice::Short RuleID;

    bool ContentFlag;

    ::Ice::Short ContentID;

    ::Ice::Short DCS;

    ::pnote::ContentList content;

    bool operator==(const DBEngineData&) const;
    bool operator!=(const DBEngineData&) const;
    bool operator<(const DBEngineData&) const;

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

}

namespace pnote
{

class AMI_DBEngineHome_find : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response(const ::pnote::DBEngineData&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    void __invoke(const ::pnote::DBEngineHomePrx&, ::Ice::Long, const ::std::string&, const ::Ice::Context&);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::pnote::AMI_DBEngineHome_find> AMI_DBEngineHome_findPtr;

class AMD_DBEngineHome_find : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response(const ::pnote::DBEngineData&) = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::pnote::AMD_DBEngineHome_find> AMD_DBEngineHome_findPtr;

}

namespace IceAsync
{

namespace pnote
{

class AMD_DBEngineHome_find : public ::pnote::AMD_DBEngineHome_find, public ::IceInternal::IncomingAsync
{
public:

    AMD_DBEngineHome_find(::IceInternal::Incoming&);

    virtual void ice_response(const ::pnote::DBEngineData&);
    virtual void ice_exception(const ::Ice::Exception&);
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace pnote
{

class DBEngineHome : virtual public ::IceProxy::Ice::Object
{
public:

    ::pnote::DBEngineData find(::Ice::Long, const ::std::string&);
    ::pnote::DBEngineData find(::Ice::Long, const ::std::string&, const ::Ice::Context&);
    void find_async(const::pnote::AMI_DBEngineHome_findPtr&, ::Ice::Long, const ::std::string&);
    void find_async(const::pnote::AMI_DBEngineHome_findPtr&, ::Ice::Long, const ::std::string&, const ::Ice::Context&);
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
};

}

}

namespace IceDelegate
{

namespace pnote
{

class DBEngineHome : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::pnote::DBEngineData find(::Ice::Long, const ::std::string&, const ::Ice::Context&) = 0;
};

}

}

namespace IceDelegateM
{

namespace pnote
{

class DBEngineHome : virtual public ::IceDelegate::pnote::DBEngineHome,
		     virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::pnote::DBEngineData find(::Ice::Long, const ::std::string&, const ::Ice::Context&);
};

}

}

namespace IceDelegateD
{

namespace pnote
{

class DBEngineHome : virtual public ::IceDelegate::pnote::DBEngineHome,
		     virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::pnote::DBEngineData find(::Ice::Long, const ::std::string&, const ::Ice::Context&);
};

}

}

namespace pnote
{

class DBEngineHome : virtual public ::Ice::Object
{
public:

    static const ::std::string __ids[2];
    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void find_async(const ::pnote::AMD_DBEngineHome_findPtr&, ::Ice::Long, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const = 0;
    ::IceInternal::DispatchStatus ___find(::IceInternal::Incoming&, const ::Ice::Current&) const;

    static ::std::string __all[5];
    virtual ::IceInternal::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
};

void __patch__DBEngineHomePtr(void*, ::Ice::ObjectPtr&);

}

#endif
